Attribute VB_Name = "Foreground"
Option Explicit

' Dieser Code holt ein Fenster n den Vordergrund.
' Er ist entnommen aus http://www.TheScarms.Com/downloads/AltTab.zip

Public Sub pSetForegroundWindow(ByVal hWnd As Long)
    Dim lForeThreadID As Long
    Dim lThisThreadID As Long
    Dim lReturn       As Long
    '
    ' Make a window, specified by its handle (hwnd)
    ' the foreground window.
    '
    ' If it is already the foreground window, exit.
    '
    If hWnd <> GetForegroundWindow() Then
        '
        ' Get the threads for this window and the foreground window.
        '
        lForeThreadID = GetWindowThreadProcessId(GetForegroundWindow, ByVal 0&)
        lThisThreadID = GetWindowThreadProcessId(hWnd, ByVal 0&)
        '
        ' By sharing input state, threads share their concept of
        ' the active window.
        '
        If lForeThreadID <> lThisThreadID Then
            ' Attach the foreground thread to this window.
            Call AttachThreadInput(lForeThreadID, lThisThreadID, True)
            ' Make this window the foreground window.
            lReturn = SetForegroundWindow(hWnd)
            ' Detach the foreground window's thread from this window.
            Call AttachThreadInput(lForeThreadID, lThisThreadID, False)
        Else
           lReturn = SetForegroundWindow(hWnd)
        End If
        '
        ' Restore this window to its normal size.
        '
        If IsIconic(hWnd) Then
           Call ShowWindow(hWnd, SW_RESTORE)
        Else
           Call ShowWindow(hWnd, SW_SHOW)
        End If
    End If
End Sub

